<?php 

/*************************************************************
*  TorrentFlux - PHP Torrent Manager
*  www.torrentflux.com
**************************************************************/
/*
    This file is part of TorrentFlux.

    TorrentFlux is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    TorrentFlux is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TorrentFlux; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Start Session and grab user
session_start();
$cfg["user"] = strtolower($_SESSION['user']);

include_once('db.php');

// Create Connection.
$db = getdb();

Authenticate();

include_once("language/".$cfg["language_file"]);
include_once("themes/".$cfg["theme"]."/index.php");
AuditAction($cfg["constants"]["hit"], $_SERVER['PHP_SELF']);
PruneDB();

// is there a stat and torrent dir?  If not then it will create it.
checkTorrentPath();
checkMakeTorrentPath();
checkLogPath();

//**********************************************************************************
// START FUNCTIONS HERE
//**********************************************************************************
if ($cfg['enable_xfer']) {
  $xfer = array();
  $newday = !mysql_num_rows(mysql_query("select 1 from tf_xfer where date = curdate() limit 1"));
  foreach (glob($cfg['torrent_file_path'].'*.stat') as $stat_filename) {
    $stat = file($stat_filename);
    $stat[5] = trim($stat[5]);
    sumUsage($stat[5], $stat[11], $stat[10], 'total');
    sumUsage($stat[5], $stat[11], $stat[10], 'month');
    sumUsage($stat[5], $stat[11], $stat[10], 'week');
    sumUsage($stat[5], $stat[11], $stat[10], 'day');
    if ($newday)
    {
      $newday = 2;
      // MySQL 4.1.0 introduced 'ON DUPLICATE KEY UPDATE' to make this easier
      if (mysql_num_rows(mysql_query("select 1 from tf_xfer where user='$stat[5]' and date=date_add(curdate(),interval -1 day) limit 1")) == 0)
        mysql_query("insert into tf_xfer set user='$stat[5]', date=date_add(curdate(),interval -1 day), download=$stat[11], upload=$stat[10]");
      else 
        mysql_query("update tf_xfer set download=download+$stat[11], upload=upload+$stat[10] where user='$stat[5]' and date=date_add(curdate(),interval -1 day)");
      if (mysql_num_rows(mysql_query("select 1 from tf_xfer where user='$stat[5]' and date=curdate() limit 1")) == 0)
        mysql_query("insert into tf_xfer set user='$stat[5]', date=curdate(), download=-$stat[11], upload=-$stat[10]");
      else
        mysql_query("update tf_xfer set download=download-$stat[11], upload=upload-$stat[10] where user='$stat[5]' and date=curdate()");
    }
  }
  if ($newday == 1)
    mysql_query("insert into tf_xfer user='$cfg[user]', date=curdate()");
  getUsage(0, 'total');
  $month_start = (date('j')>=$cfg['month_start']) ? date('Y-m-').$cfg['month_start'] : date('Y-m-',strtotime('-1 Month')).$cfg['month_start'];
  getUsage($month_start, 'month');
  $week_start = date('Y-m-d',strtotime('last '.$cfg['week_start']));
  getUsage($week_start, 'week');
  $day_start = date('Y-m-d');
  getUsage($day_start, 'day');
}

function getUsage($start, $period)
{
  global $xfer;
  $sql = "select user, sum(download) as download, sum(upload) as upload from tf_xfer where date >= '$start' group by user";
  $query = mysql_query($sql);
  while ($row = mysql_fetch_row($query))
    sumUsage($row[0], $row[1], $row[2], $period);
}

function sumUsage($user, $download, $upload, $period)
{
  global $xfer;
  $xfer[$period]['user'][$user]['download'] += $download;
  $xfer[$period]['user'][$user]['upload'] += $upload;
  $xfer[$period]['user'][$user]['total'] += $download + $upload;
  $xfer[$period]['server']['download'] += $download;
  $xfer[$period]['server']['upload'] += $upload;
  $xfer[$period]['server']['total'] += $download + $upload;
}

function saveXfer($user, $down, $up)
{
  if (mysql_num_rows(mysql_query("select 1 from tf_xfer where user='$user' and date=curdate() limit 1")) == 0)
    mysql_query("insert into tf_xfer set user='$user', date=curdate(), download=$down, upload=$up");
  else
    mysql_query("update tf_xfer set download=download+$down, upload=upload+$up where user='$user' and date=curdate()");
}

function displayXferBar($total, $used, $title)
{
  global $cfg;
  $remaining = $total-$used/(1024*1024);
  $percent = round($remaining/$total*100,0);
  $text = formatFreeSpace($remaining).' '._REMAINING;
  echo '<table width="100%" border="0" cellpadding="0" cellspacing="0">';
  echo '<tr nowrap>';
    echo "<td width='2%'><div class='tiny'>$title</div></td>";
    echo '<td width="80%">';
      echo '<table width="100%" border="0" cellpadding="0" cellspacing="0">';
      echo '<tr>';
        echo "<td background='themes/$cfg[theme]/images/proglass.gif' width='$percent%'>";
          if ($percent >= 50) echo "<div class='tinypercent' align='center'>$percent%($text)</div>";
        echo '</td>';
        echo "<td background='themes/$cfg[theme]/images/noglass.gif' width='".(100-$percent)."%'>";
          if ($percent < 50) echo "<div class='tinypercentneg' align='center'>$percent%($text)</div>";
        echo '</td>';
      echo '</tr>';
      echo '</table>';
    echo '</td>';
  echo '</tr>';
  echo '</table>';
}

function displayXfer()
{
  global $cfg;
  DisplayHead(_XFER);
    displayMenu();
    displayXferList();
    if (isset($_GET['user'])) {
      echo '<br><b>';
        echo ($_GET['user'] == '%') ? _SERVERXFERSTATS : _USERDETAILS.': '.$_GET['user'];
      echo '</b><br>';
      displayXferDetail($_GET['user'],_MONTHSTARTING,0,0);
      if ($_GET['month']) {
        $mstart = $_GET['month'].'-'.$cfg['month_start'];
        $mend = date('Y-m-d',strtotime('+1 Month',strtotime($mstart)));
      } else {
        $mstart = 0;
        $mend = 0;
      }
      if ($_GET['week']) {
        $wstart = $_GET['week'];
        $wend = date('Y-m-d',strtotime('+1 Week',strtotime($_GET['week'])));
      } else {
        $wstart = $mstart;
        $wend = $mend;
      }
      displayXferDetail($_GET['user'],_WEEKSTARTING,$mstart,$mend);
      displayXferDetail($_GET['user'],_DAY,$wstart,$wend);
    }
  DisplayFoot();
}

function displayXferDetail($user_id,$period,$period_start,$period_end)
{
  global $cfg, $xfer;
  $period_query = ($period_start) ? "and date >= '$period_start' and date < '$period_end' and date < '$period_end'" : '';
  $query = mysql_query("select sum(download) as download, sum(upload) as upload, date from tf_xfer where user like '$user_id' $period_query group by date order by date");
  echo "<table width='760' border=1 bordercolor='$cfg[table_admin_border]' cellpadding='2' cellspacing='0' bgcolor='$cfg[table_data_bg]'>";
    echo '<tr>';
      echo "<td bgcolor='$cfg[table_header_bg]' width='20%'><div align=center class='title'>$period</div></td>";
      echo "<td bgcolor='$cfg[table_header_bg]' width='27%'><div align=center class='title'>"._TOTAL.'</div></td>';
      echo "<td bgcolor='$cfg[table_header_bg]' width='27%'><div align=center class='title'>"._DOWNLOAD.'</div></td>';
      echo "<td bgcolor='$cfg[table_header_bg]' width='27%'><div align=center class='title'>"._UPLOAD.'</div></td>';
    echo '</tr>';
    $start = '';
    $download = 0;
    $upload = 0;
    while ($row = mysql_fetch_row($query)) {
      $rtime = strtotime($row[2]);
      switch ($period) {
        case 'Month Starting':
          $newstart = $cfg['month_start'].' ';
          $newstart .= (date('j',$rtime) < $cfg['month_start']) ? date('M Y',strtotime('-1 Month',$rtime)) : date('M Y',$rtime);
        break;
        case 'Week Starting': $newstart = date('d M Y',strtotime('+1 Day last '.$cfg['week_start'],$rtime)); break;
        case 'Day': $newstart = $row[2]; break;
      }
      if ($row[2] == date('Y-m-d')) {
        if ($user_id == '%') {
          $row[0] = $xfer['day']['server']['download'];
          $row[1] = $xfer['day']['server']['upload'];
        } else {
          $row[0] = $xfer['day']['user'][$user_id]['download'];
          $row[1] = $xfer['day']['user'][$user_id]['upload'];
        }
      }
      if ($start != $newstart) {
        if ($upload + $download != 0) {
          echo '<tr>';
            echo "<td>$rowstr</td>";
            $downloadstr = formatFreeSpace($download/(1024*1024));
            $uploadstr = formatFreeSpace($upload/(1024*1024));
            $totalstr = formatFreeSpace(($download+$upload)/(1024*1024));
            echo "<td><div class='tiny' align='center'><b>$totalstr</b></div></td>";
            echo "<td><div class='tiny' align='center'>$downloadstr</div></td>";
            echo "<td><div class='tiny' align='center'>$uploadstr</div></td>";
          echo '</tr>';
        }
        $download = $row[0];
        $upload = $row[1];
        $start = $newstart;
      } else {
        $download += $row[0];
        $upload += $row[1];
      }
      switch ($period) {
        case 'Month Starting': $rowstr = "<a href='?op=xfer&user=$user_id&month=".date('Y-m',strtotime($start))."'>$start</a>"; break;
        case 'Week Starting': $rowstr = "<a href='?op=xfer&user=$user_id&month=$_GET[month]&week=".date('Y-m-d',strtotime($start))."'>$start</a>"; break;
        case 'Day': $rowstr = $start; break;
      }
    }
    if ($upload + $download != 0) {
      echo '<tr>';
        echo "<td>$rowstr</td>";
        $downloadstr = formatFreeSpace($download/(1024*1024));
        $uploadstr = formatFreeSpace($upload/(1024*1024));
        $totalstr = formatFreeSpace(($download+$upload)/(1024*1024));
        echo "<td><div class='tiny' align='center'><b>$totalstr</b></div></td>";
        echo "<td><div class='tiny' align='center'>$downloadstr</div></td>";
        echo "<td><div class='tiny' align='center'>$uploadstr</div></td>";
      echo '</tr>';
    }
  echo '</table><br>';
}

function displayXferList()
{
  global $cfg, $xfer;
    echo "<table width='760' border=1 bordercolor='$cfg[table_admin_border]' cellpadding='2' cellspacing='0' bgcolor='$cfg[table_data_bg]'>";
      echo '<tr>';
        echo "<td bgcolor='$cfg[table_header_bg]' width='15%'><div align=center class='title'>"._USER.'</div></td>';
        echo "<td bgcolor='$cfg[table_header_bg]' width='22%'><div align=center class='title'>"._TOTALXFER.'</div></td>';
        echo "<td bgcolor='$cfg[table_header_bg]' width='22%'><div align=center class='title'>"._MONTHXFER.'</div></td>';
        echo "<td bgcolor='$cfg[table_header_bg]' width='22%'><div align=center class='title'>"._WEEKXFER.'</div></td>';
        echo "<td bgcolor='$cfg[table_header_bg]' width='22%'><div align=center class='title'>"._DAYXFER.'</div></td>';
      echo '</tr>';
      $result = mysql_query('select user_id from tf_users order by user_id');
      while(list($user_id) = mysql_fetch_row($result))
      {
        echo '<tr>';
          echo "<td><a href='?op=xfer&user=$user_id'>$user_id</a></td>";
          $total = formatFreeSpace($xfer['total']['user'][$user_id]['total']/(1024*1024));
          $month = formatFreeSpace($xfer['month']['user'][$user_id]['total']/(1024*1024));
          $week = formatFreeSpace($xfer['week']['user'][$user_id]['total']/(1024*1024));
          $day = formatFreeSpace($xfer['day']['user'][$user_id]['total']/(1024*1024));
          echo "<td><div class='tiny' align='center'>$total</div></td>";
          echo "<td><div class='tiny' align='center'>$month</div></td>";
          echo "<td><div class='tiny' align='center'>$week</div></td>";
          echo "<td><div class='tiny' align='center'>$day</div></td>";
        echo '</tr>';
      }
      echo '<td><a href="?op=xfer&user=%"><b>'._TOTAL.'</b></a></td>';
      $total = formatFreeSpace($xfer['total']['server']['total']/(1024*1024));
      $month = formatFreeSpace($xfer['month']['server']['total']/(1024*1024));
      $week = formatFreeSpace($xfer['week']['server']['total']/(1024*1024));
      $day = formatFreeSpace($xfer['day']['server']['total']/(1024*1024));
      echo "<td><div class='tiny' align='center'><b>$total</b></div></td>";
      echo "<td><div class='tiny' align='center'><b>$month</b></div></td>";
      echo "<td><div class='tiny' align='center'><b>$week</b></div></td>";
      echo "<td><div class='tiny' align='center'><b>$day</b></div></td>";
    echo '</table>';
}

//*********************************************************
// select_option()
function select_option($option,$select1,$select2)
{
if ($option == $select1)
  echo "<option value=$select1 selected>".strtolower($select1)."</option><option value=$select2>".strtolower($select2)."</option>";
else
  echo "<option value=$select1>".strtolower($select1)."</option><option value=$select2 selected>".strtolower($select2)."</option>";
}

function GetSpeedInBytes($inValue)
{
	$rtnValue = 0;
	$arTemp = split(" ", trim($inValue));
	if ($arTemp[1] == "kB/s")
		$rtnValue = $arTemp[0] * 1024;
	else
		$rtnValue = $arTemp[0];
	return $rtnValue;
}

function SecondsToDate($seconds)
{
      $periods = array (
                    'yx'     => 31556926,
                    'mx'    => 2629743,
                    'wx'     => 604800,
                    'dx'      => 86400,
                    'hx'     => 3600,
                    'minx'   => 60,
                    'secx'   => 1
      );
      $seconds = (float) $seconds;
      foreach ($periods as $period => $value) {
          $count = floor($seconds / $value);  
          if ($count == 0) {
              continue;
          }
          $values[$period] = $count;
          $seconds = $seconds % $value;
      }
      if (empty($values)) {
          $values = null;
      }
      foreach ($values as $key => $value) {
          $segment_name = substr($key, 0, -1);
          $segment = $value . ' ' . $segment_name; 
          if ($value != 1) {
              $segment .= '';
          }
          $array[] = $segment;
      }
      return implode(', ', $array);
}


//*********************************************************
// avddelete()
function avddelete($file)
{
	chmod($file,0777);
	if (@is_dir($file))
	{
		$handle = @opendir($file);
		while($filename = readdir($handle))
		{
			if ($filename != "." && $filename != "..")
			{
				avddelete($file."/".$filename);
			}
		}
		closedir($handle);
		@rmdir($file);
	}
	else
	{
		@unlink($file);
	}
}


//*********************************************************
// Authenticate()
function Authenticate()
{
	global $cfg, $db;
	
	$create_time = time();
	
	if(!isset($_SESSION['user']))
	{
		header('location: login.php');
		exit();
	}
	
	if ($_SESSION['user'] == md5($cfg["pagetitle"]))
	{
		// user changed password and needs to login again
		header('location: logout.php');
		exit();
	}
	
	$sql = "SELECT uid, hits, hide_offline, theme, language_file FROM tf_users WHERE user_id=".$db->qstr($cfg['user']);
	$recordset = $db->Execute($sql);
	showError($db, $sql);

	if($recordset->RecordCount() != 1)
	{
		AuditAction($cfg["constants"]["error"], "FAILED AUTH: ".$cfg['user']);
		session_destroy();
		header('location: login.php');
		exit();
	}

	list($uid, $hits, $cfg["hide_offline"], $cfg["theme"], $cfg["language_file"]) = $recordset->FetchRow();

	// Check for valid theme
	if (!ereg('^[^./][^/]*$', $cfg["theme"]))
	{
		AuditAction($cfg["constants"]["error"], "THEME VARIABLE CHANGE ATTEMPT: ".$cfg["theme"]." from ".$cfg['user']);
		$cfg["theme"] = $cfg["default_theme"];
	}
	
	// Check for valid language file
	if(!ereg('^[^./][^/]*$', $cfg["language_file"]))
	{
		AuditAction($cfg["constants"]["error"], "LANGUAGE VARIABLE CHANGE ATTEMPT: ".$cfg["language_file"]." from ".$cfg['user']);
		$cfg["language_file"] = $cfg["default_language"];
	}
	
	if (!is_dir("themes/".$cfg["theme"]))
	{
		$cfg["theme"] = $cfg["default_theme"];
	}
	
	// Check for valid language file
	if (!is_file("language/".$cfg["language_file"]))
	{
		$cfg["language_file"] = $cfg["default_language"];
	}
	
	$hits++;

	$sql = 'select * from tf_users where uid = '.$uid;
	$rs = $db->Execute($sql);
	showError($db, $sql);

	$rec = array(
					'hits' => $hits,
					'last_visit' => $create_time,
					'theme' => $cfg['theme'],
					'language_file' => $cfg['language_file']
				);
	$sql = $db->GetUpdateSQL($rs, $rec);

	$result = $db->Execute($sql);
	showError($db,$sql);
}


//*********************************************************
// AuditAction
function AuditAction($action, $file="")
{
	global $_SERVER, $cfg, $db;
	
	$host_resolved = gethostbyaddr($cfg['ip']);
	$create_time = time();

	$rec = array(
					'user_id' => $cfg['user'], 
					'file' => $file, 
					'action' => $action, 
					'ip' => $cfg['ip'], 
					'ip_resolved' => $host_resolved, 
					'user_agent' => $_SERVER['HTTP_USER_AGENT'],
					'time' => $create_time
				);

	$sTable = 'tf_log';
	$sql = $db->GetInsertSql($sTable, $rec);

	// add record to the log
	$result = $db->Execute($sql);
	showError($db,$sql);
}

//*********************************************************
// SaveMessage
function SaveMessage($to_user, $from_user, $message, $to_all=0, $force_read=0)
{
	global $_SERVER, $cfg, $db;
	
	$message = str_replace(array("'"), "", $message);
	
	$create_time = time();
	
	$sTable = 'tf_messages';
	if($to_all == 1)
	{
		$message .= "\n\n__________________________________\n*** "._MESSAGETOALL." ***";
		$sql = 'select user_id from tf_users';
		$result = $db->Execute($sql);
		showError($db,$sql);

		while($row = $result->FetchRow())
		{
			$rec = array(
						'to_user' => $row['user_id'],
						'from_user' => $from_user,
						'message' => $message,
						'IsNew' => 1,
						'ip' => $cfg['ip'],
						'time' => $create_time,
						'force_read' => $force_read
						);
			
			$sql = $db->GetInsertSql($sTable, $rec);

			$result2 = $db->Execute($sql);
			showError($db,$sql);
		}
	}
	else
	{
		// Only Send to one Person
		$rec = array(
					'to_user' => $to_user,
					'from_user' => $from_user,
					'message' => $message,
					'IsNew' => 1,
					'ip' => $cfg['ip'],
					'time' => $create_time,
					'force_read' => $force_read
					);
		$sql = $db->GetInsertSql($sTable, $rec);
		$result = $db->Execute($sql);
		showError($db,$sql);
	}
	
}

//*********************************************************
function addNewUser($newUser, $pass1, $userType)
{
	global $cfg, $db;

	$create_time = time();

	$record = array(
					'user_id'=>strtolower($newUser),
					'password'=>md5($pass1),
					'hits'=>0,
					'last_visit'=>$create_time,
					'time_created'=>$create_time,
					'user_level'=>$userType,
					'hide_offline'=>$cfg["hide_offline"],
					'theme'=>$cfg["default_theme"],
					'language_file'=>$cfg["default_language"]
					);

	$sTable = 'tf_users';
	$sql = $db->GetInsertSql($sTable, $record);
	$result = $db->Execute($sql);
	showError($db,$sql);
}

//*********************************************************
function PruneDB()
{
	global $cfg, $db;

	// Prune LOG
	$testTime = time()-($cfg['days_to_keep'] * 86400); // 86400 is one day in seconds
	$sql = "delete from tf_log where time < " . $db->qstr($testTime);
	$result = $db->Execute($sql);
	showError($db,$sql);
	unset($result);
	
	$testTime = time()-($cfg['minutes_to_keep'] * 60); 
	$sql = "delete from tf_log where time < " . $db->qstr($testTime). " and action=".$db->qstr($cfg["constants"]["hit"]);
	$result = $db->Execute($sql);
	showError($db,$sql);
	unset($result);
}

//*********************************************************
function IsOnline($user)
{
	global $cfg, $db;

	$online = false;

	$sql = "SELECT count(*) FROM tf_log WHERE user_id=" . $db->qstr($user)." AND action=".$db->qstr($cfg["constants"]["hit"]);

	$number_hits = $db->GetOne($sql);
	showError($db,$sql);

	if ($number_hits > 0)
	{
		$online = true;
	}
	
	return $online;
}

//*********************************************************
function IsUser($user)
{
	global $cfg, $db;

	$isUser = false;

	$sql = "SELECT count(*) FROM tf_users WHERE user_id=".$db->qstr($user);
	$number_users = $db->GetOne($sql);

	if ($number_users > 0)
	{
		$isUser = true;
	}
	
	return $isUser;
}

//*********************************************************
function getOwner($file)
{
	global $cfg, $db;

	$rtnValue = "n/a";
	
	// Check log to see what user has a history with this file
	$sql = "SELECT user_id FROM tf_log WHERE file=".$db->qstr($file)." AND (action=".$db->qstr($cfg["constants"]["file_upload"])." OR action=".$db->qstr($cfg["constants"]["url_upload"]).") ORDER  BY time DESC";
	$user_id = $db->GetOne($sql);

	if($user_id != "")
	{
		$rtnValue = $user_id;
	}
	
	return $rtnValue;
}
//*********************************************************
function getSite($lid)
{
global $cfg, $db;

$rtnValue = "";

$sql = "SELECT sitename FROM tf_links WHERE lid=".$lid;
$rtnValue = $db->GetOne($sql);

return $rtnValue;
}

//*********************************************************
function getLink($lid)
{
	global $cfg, $db;

	$rtnValue = "";
	
	$sql = "SELECT url FROM tf_links WHERE lid=".$lid;
	$rtnValue = $db->GetOne($sql);

	return $rtnValue;
}

//*********************************************************
function getRSS($rid)
{
	global $cfg, $db;

	$rtnValue = "";
	
	$sql = "SELECT url FROM tf_rss WHERE rid=".$rid;
	$rtnValue = $db->GetOne($sql);

	return $rtnValue;
}

//*********************************************************
function IsOwner($user, $owner)
{
	$rtnValue = false;
	
	if (strtolower($user) == strtolower($owner))
	{
		$rtnValue = true;
	}
	
	return $rtnValue;
}

//*********************************************************
function GetActivityCount($user="")
{
	global $cfg, $db;

	$count = 0;
	$for_user = "";
	
	if ($user != "")
	{
		$for_user = "user_id=".$db->qstr($user)." AND ";
	}

	$sql = "SELECT count(*) FROM tf_log WHERE ".$for_user."(action=".$db->qstr($cfg["constants"]["file_upload"])." OR action=".$db->qstr($cfg["constants"]["url_upload"]).")";
	$count = $db->GetOne($sql);

	return $count;
}

//*********************************************************
function GetSpeedValue($inValue)
{
	$rtnValue = 0;
	$arTemp = split(" ", trim($inValue));
	
	if (is_numeric($arTemp[0]))
	{
		$rtnValue = $arTemp[0];
	}
	return $rtnValue;
}

// ***************************************************************************
// Is User Admin
// user is Admin if level is 1 or higher
function IsAdmin($user="")
{
	global $cfg, $db;

	$isAdmin = false;
	
	if($user == "")
	{
		$user = $cfg["user"];
	}
	
	$sql = "SELECT user_level FROM tf_users WHERE user_id=".$db->qstr($user);
	$user_level = $db->GetOne($sql);
	
	if ($user_level >= 1)
	{
		$isAdmin = true;
	}
	return $isAdmin;
}

// ***************************************************************************
// Is User SUPER Admin
// user is Super Admin if level is higher than 1
function IsSuperAdmin($user="")
{
	global $cfg, $db;

	$isAdmin = false;
	
	if($user == "")
	{
		$user = $cfg["user"];
	}
	
	$sql = "SELECT user_level FROM tf_users WHERE user_id=".$db->qstr($user);
	$user_level = $db->GetOne($sql);
	
	if ($user_level > 1)
	{
		$isAdmin = true;
	}
	return $isAdmin;
}


// ***************************************************************************
// Returns true if user has message from admin with force_read
function IsForceReadMsg()
{
	global $cfg, $db;
	$rtnValue = false;
	
	$sql = "SELECT count(*) FROM tf_messages WHERE to_user=".$db->qstr($cfg["user"])." AND force_read=1";
	$count = $db->GetOne($sql);
	showError($db,$sql);
	
	if ($count >= 1)
	{
		$rtnValue = true;
	}
	return $rtnValue;
}
// ***************************************************************************
// User PM Notify Hack by: Reyna12
// Returns true if user has message from user
function IsUserReadMsg()
{
	global $cfg, $db;
	$rtnValue = false;
	
	$sql = "SELECT count(*) FROM tf_messages WHERE to_user=".$db->qstr($cfg["user"])." AND IsNew=1";
	$count = $db->GetOne($sql);
	showError($db,$sql);
	
	if ($count >= 1)
	{
		$rtnValue = true;
	}
	return $rtnValue;
}
// ***************************************************************************
// Get Message data in an array
function GetMessage($mid)
{
	global $cfg, $db;
	
	$sql = "select from_user, message, ip, time, isnew, force_read from tf_messages where mid=".$mid." and to_user=".$db->qstr($cfg['user']);

	return $db->GetRow($sql);
	showError($db,$sql);
}

// ***************************************************************************
// Get Themes data in an array
function GetThemes()
{
	$arThemes = array();
	$dir = "themes/";
	
	$handle = opendir($dir);
	while($entry = readdir($handle)) 
	{
		if (is_dir($dir.$entry) && ($entry != "." && $entry != "..")) 
		{
			array_push($arThemes, $entry);
		}
	}
	closedir($handle);
	
	sort($arThemes);
	
	return $arThemes;
}

// ***************************************************************************
// Get Languages in an array
function GetLanguages()
{
	$arLanguages = array();
	$dir = "language/";
	
	$handle = opendir($dir);
	while($entry = readdir($handle)) 
	{
		if (is_file($dir.$entry) && (strcmp(strtolower(substr($entry, strlen($entry)-4, 4)), ".php") == 0)) 
		{
			array_push($arLanguages, $entry);
		}
	}
	closedir($handle);
	
	sort($arLanguages);
	
	return $arLanguages;
}

// ***************************************************************************
// Get Language name from file name
function GetLanguageFromFile($inFile)
{
	$rtnValue = "";
	
	$rtnValue = str_replace("lang-", "", $inFile);
	$rtnValue = str_replace(".php", "", $rtnValue);
	
	return $rtnValue;
}



// ***************************************************************************
// Delete Message
function DeleteMessage($mid)
{
	global $cfg, $db;
	
	$sql = "delete from tf_messages where mid=".$mid." and to_user=".$db->qstr($cfg['user']);
	$result = $db->Execute($sql);
	showError($db,$sql);
}


// ***************************************************************************
// Delete Link
function deleteOldLink($lid)
{	
	global $db;
	$sql = "delete from tf_links where lid=".$lid;
	$result = $db->Execute($sql);
	showError($db,$sql);
}

// ***************************************************************************
// Delete RSS
function deleteOldRSS($rid)
{	
	global $db;
	$sql = "delete from tf_rss where rid=".$rid;
	$result = $db->Execute($sql);
	showError($db,$sql);
}

// ***************************************************************************
// Delete User
function DeleteThisUser($user_id)
{
	global $db;

	$sql = "DELETE FROM tf_users WHERE user_id=".$db->qstr($user_id);
	$result = $db->Execute($sql);
	showError($db,$sql);
	
	// Now cleanup any message this person may have had
	$sql = "DELETE FROM tf_messages WHERE to_user=".$db->qstr($user_id);
	$result = $db->Execute($sql);
	showError($db,$sql);
}

// ***************************************************************************
// Update User -- used by admin
function updateThisUser($user_id, $org_user_id, $pass1, $userType, $hideOffline)
{
	global $db;

	$setter = "";
	
	if ($hideOffline == "")
	{
		$hideOffline = 0;
	}
	
	if ($pass1 != "")
	{
		$setter .= "password=".$db->qstr(md5($pass1)).",";
	}
	
	$sql = 'select * from tf_users where user_id = '.$db->qstr($org_user_id);
	$rs = $db->Execute($sql);
	showError($db,$sql);

	$rec = array(
				'user_id'=>$user_id,
				'user_level'=>$userType,
				'hide_offline'=>$hideOffline
				);
	$sql = $db->GetUpdateSQL($rs, $rec);

	$result = $db->Execute($sql);
	showError($db,$sql);
	
	// if the original user id and the new id do not match, we need to update messages and log
	if ($user_id != $org_user_id)
	{
		$sql = "UPDATE tf_messages SET to_user=".$db->qstr($user_id)." WHERE to_user=".$db->qstr($org_user_id);

		$result = $db->Execute($sql);
		showError($db,$sql);

		$sql = "UPDATE tf_messages SET from_user=".$db->qstr($user_id)." WHERE from_user=".$db->qstr($org_user_id);
		$result = $db->Execute($sql);
		showError($db,$sql);

		$sql = "UPDATE tf_log SET user_id=".$db->qstr($user_id)." WHERE user_id=".$db->qstr($org_user_id);
		$result = $db->Execute($sql);
		showError($db,$sql);
	}
}

// ***************************************************************************
// changeUserLevel Changes the Users Level
function changeUserLevel($user_id, $level)
{
	global $db;
	
	$sql='select * from tf_users where user_id = '.$db->qstr($user_id);
	$rs = $db->Execute($sql);
	showError($db,$sql);

	$rec = array('user_level'=>$level);
	$sql = $db->GetUpdateSQL($rs, $rec);
	$result = $db->Execute($sql);
	showError($db,$sql);
}

// ***************************************************************************
// Mark Message as Read
function MarkMessageRead($mid)
{
	global $cfg, $db;
	
	$sql = 'select * from tf_messages where mid = '.$mid;
	$rs = $db->Execute($sql);
	showError($db,$sql);

	$rec = array('IsNew'=>0, 
		     'force_read'=>0);

	$sql = $db->GetUpdateSQL($rs, $rec);
	$db->Execute($sql);
	showError($db,$sql);
}


//**************************************************************************
// alterLink()
// This function updates the database and alters the selected links values

function alterLink($lid,$newLink,$newSite)
{
global $cfg, $db;

$sql = "UPDATE tf_links SET url='".$newLink."',`sitename`='".$newSite."' WHERE `lid` = ".$lid." LIMIT 1";
$db->Execute($sql);
showError($db,$sql);

}

// ***************************************************************************
// addNewLink - Add New Link
function addNewLink($newLink,$newSite)
{	
	global $db;
	$rec = array('url'=>$newLink,'sitename'=>$newSite);
	$sTable = 'tf_links';
	$sql = $db->GetInsertSql($sTable, $rec);
	$db->Execute($sql);
	showError($db,$sql);
}


// ***************************************************************************
// addNewRSS - Add New RSS Link
function addNewRSS($newRSS)
{	
	global $db;
	$rec = array('url'=>$newRSS);
	$sTable = 'tf_rss';
	$sql = $db->GetInsertSql($sTable, $rec);
	$db->Execute($sql);
	showError($db,$sql);
}

// ***************************************************************************
// UpdateUserProfile
function UpdateUserProfile($user_id, $pass1, $hideOffline, $theme, $language)
{
	global $cfg, $db;
	$setter = "";
	
	if (empty($hideOffline) || $hideOffline == "" || !isset($hideOffline))
	{
		$hideOffline = "0";
	}

	// update values
	$rec = array();
	
	if ($pass1 != "")
	{
		$rec['password'] = md5($pass1);
		AuditAction($cfg["constants"]["update"], _PASSWORD);
	}
	
	$sql = 'select * from tf_users where user_id = '.$db->qstr($user_id);
	$rs = $db->Execute($sql);
	showError($db,$sql);

	$rec['hide_offline'] = $hideOffline;
	$rec['theme'] = $theme;
	$rec['language_file'] = $language;

	$sql = $db->GetUpdateSQL($rs, $rec);
	
	$result = $db->Execute($sql);
	showError($db,$sql);
}


// ***************************************************************************
// Get Users in an array
function GetUsers()
{
	global $cfg, $db;
	
	$user_array = array();
	
	$sql = "select user_id from tf_users order by user_id";
	$user_array = $db->GetCol($sql);
	showError($db,$sql);
	return $user_array;
}

// ***************************************************************************
// Get Links in an array
function GetLinks()
{
	global $cfg, $db;
	
	$link_array = array();
	
	$link_array = $db->GetAssoc("SELECT lid, url, sitename FROM tf_links ORDER BY sitename");
	return $link_array;
}

// ***************************************************************************
// Get RSS Links in an array
function GetRSSLinks()
{
	global $cfg, $db;
	
	$link_array = array();

	$sql = "SELECT rid, url FROM tf_rss ORDER BY rid";
	$link_array = $db->GetAssoc($sql);
	showError($db,$sql);

	return $link_array;
}

//*********************************************************
function getAllow($aid)
{
	Global $cfg, $db;
	$rtnValue = "";

	$sql = "SELECT ip FROM tf_allowed WHERE aid=".$aid;
	$query = $db->Execute($sql);
	list($rtnValue) = $query->GetRows();

	return $rtnValue;
}

// ***************************************************************************
// Get IPSEC Rules in an array
function GetAllows()
{
	global $cfg, $db;

	$allow_array = array();
	$allow_array = $db->GetAssoc("SELECT aid, ip FROM tf_allowed ORDER BY aid");

	return $allow_array;
}

// ***************************************************************************
// deleteOldAllow - Delete IPSEC Rule
function deleteOldAllow($aid)
{
	global $db;
	$sql = "delete from tf_allowed where aid=".$aid;
	$result = $db->Execute($sql);
	showError($db,$sql);
}

// ***************************************************************************
// addNewAllow - Add New IPSEC Rule
function addNewAllow($newIP)
{
	global $db;
	$sTable = "tf_allowed";
	$rec = array(
				'aid'=>"",
				'ip'=>$newIP
				);
	$sql = $db->GetInsertSQL($sTable, $rec);
	$result = $db->Execute($sql);
	showError($db, $sql);
}

// ***************************************************************************
// ***************************************************************************
// Display Functions



// ***************************************************************************
// ***************************************************************************
// Display the header portion of admin views
function DisplayHead($subTopic, $showButtons=true, $refresh="", $percentdone="", $dtree=false)
{
	global $cfg;
	?>

	<html>
	<HEAD>
    <TITLE><?php echo $percentdone.$cfg["pagetitle"] ?></TITLE>
 <link rel="icon" href="images/favicon.ico" type="image/x-icon" />
 <link rel="shortcut icon" href="images/favicon.ico" type="image/x-icon" />
    <LINK REL="StyleSheet" HREF="themes/<?php echo $cfg["theme"] ?>/style.css" TYPE="text/css">
<script type="text/javascript">
function CheckOpen (url) {
var width = screen.width/2-300;
var height = screen.height/2-110;
var InfoWin = window.open("maketorrent.php?url="+url, "MakeTorrent", "status=no,toolbar=no,scrollbars=no,resizable=no,menubar=no,width=500,height=110,left="+width+",top="+height);

}
</script> 
<META HTTP-EQUIV="Pragma" CONTENT="no-cache; charset=<?php echo _CHARSET ?>">
		
	<?php
	if ($refresh != "")
	{
		echo "<meta http-equiv=\"REFRESH\" content=\"".$refresh."\">";
	}
	if ($dtree == true)
	{
		echo '<link rel="StyleSheet" href="dtree.css" type="text/css" /><script type="text/javascript" src="dtree.js"></script>';
	}
	?>
	</HEAD>

	<body topmargin="8" leftmargin="5" bgcolor="<?php echo $cfg["main_bgcolor"] ?>">

	<div align="center">
	<table border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td>
		
	<table border="1" bordercolor="<?php echo $cfg["table_border_dk"] ?>" cellpadding="4" cellspacing="0">
	<tr>
	    <td bgcolor="<?php echo $cfg["main_bgcolor"] ?>" background="themes/<?php echo $cfg["theme"] ?>/images/bar.gif">
		<?php DisplayTitleBar($cfg["pagetitle"]." - ".$subTopic, $showButtons); ?>
	    </td>
	</tr>
	<tr>
	<td bgcolor="<?php echo $cfg["table_header_bg"] ?>">
	<div align="center">

	<table width="100%" bgcolor="<?php echo $cfg["body_data_bg"] ?>">
	 <tr><td>
<?php
}


// ***************************************************************************
// ***************************************************************************
// Display the footer portion
function DisplayFoot($showReturn=true)
{
	global $cfg;
	?>
	 </td></tr>
	</table>
<?php
	if ($showReturn)
	{
		echo "[<a href=\"index.php\">"._RETURNTOTORRENTS."</a>]";
	}
?>
	</div>
	</td>
	</tr>
	</table>

<?php 
	echo DisplayTorrentFluxLink(); 
?>
	
		</td>
	</tr>
	</table>
	</div>
	
	</body>
	</html>

	<?php
}


// ***************************************************************************
// ***************************************************************************
// Dipslay TF Link and Version
function DisplayTorrentFluxLink()
{
	global $cfg;
	
	echo "<div align=\"right\">";
	echo "<a href=\"http://www.torrentflux.com\" target=\"_blank\"><font class=\"tinywhite\">TorrentFlux ".$cfg["version"]."</font></a>&nbsp;<a href=\"http://opptorrentflux.6x.to\" target=\"_blank\"><font class=\"tinywhite\">".$cfg["oppversion"]."</font></a>&nbsp;&nbsp;";
	echo "</div>";
}


// ***************************************************************************
// ***************************************************************************
// Dipslay Title Bar
// 2004-12-09 PFM: now using adodb.
function DisplayTitleBar($pageTitleText, $showButtons=true)
{
	global $cfg, $db;
	?>
		<table width="100%" cellpadding="0" cellspacing="0" border="0">
		<tr>
			<td align="left"><font class="title"><?php echo $pageTitleText ?></font></td>

	<?php
	if ($showButtons)
	{
		echo "<td align=right>";
		// Top Buttons
		echo "&nbsp;&nbsp;";

		echo "<a href=\"index.php\"><img src=\"themes/".$cfg["theme"]."/images/home.gif\" width=58 height=13 title=\""._TORRENTS."\" border=0></a>&nbsp;";

		echo "<a href=\"dir.php\"><img src=\"themes/".$cfg["theme"]."/images/directory.gif\" width=70 height=13 title=\""._DIRECTORYLIST."\" border=0></a>&nbsp;";

		echo "<a href=\"history.php\"><img src=\"themes/".$cfg["theme"]."/images/history.gif\" width=58 height=13 title=\""._UPLOADHISTORY."\" border=0></a>&nbsp;";

		echo "<a href=\"profile.php\"><img src=\"themes/".$cfg["theme"]."/images/profile.gif\" width=58 height=13 title=\""._MYPROFILE."\" border=0></a>&nbsp;";

		// Does the user have messages?
		$sql = "select count(*) from tf_messages where to_user='".$cfg['user']."' and IsNew=1";

		$number_messages = $db->GetOne($sql);
		showError($db,$sql);
		if ($number_messages > 0)
		{
			// We have messages
			$message_image = "themes/".$cfg["theme"]."/images/messages_on.gif";
		}
		else
		{
			// No messages
			$message_image = "themes/".$cfg["theme"]."/images/messages_off.gif";
		}

		echo "<a href=\"readmsg.php\"><img src=\"".$message_image."\" width=58 height=13 title=\""._MESSAGES."\" border=0></a>";

		if(IsAdmin())
		{
			echo "&nbsp;<a href=\"admin.php\"><img src=\"themes/".$cfg["theme"]."/images/admin.gif\" width=49 height=13 title=\""._ADMINISTRATION."\" border=0></a>";
		}
		
    if ($cfg["xmlinfo"])
		{
			echo "&nbsp;<a target=\"_blank\" href=\"xmlout.php\"><img src=\"images/xml_logo.gif\" width=69 height=13 title=\"XML Feed\" border=0></a>";
		}
		
		echo "&nbsp;<a href=\"logout.php\"><img src=\"images/logout.gif\" width=13 height=12 title=\"Logout\" border=0></a>";
	}
?>
			</td>
		</tr>
		</table>
<?php
}


// ***************************************************************************
// ***************************************************************************
// Dipslay dropdown list to send message to a user
function DisplayMessageList()
{
	global $cfg;
	$users = GetUsers();
?>
	<div align="center">
	<table border="0" cellpadding="0" cellspacing="0">
	<form name="formMessage" action="message.php" method="post">
	<tr>
		<td>
		<?php echo _SENDMESSAGETO ?>:
		<select name="to_user">
<?php
		for($inx = 0; $inx < sizeof($users); $inx++)
		{
			echo "<option value=\"".$users[$inx]."\">".$users[$inx]."</option>";
		}
?>
		</select>
		<input type="Submit" value="<?php echo _COMPOSE ?>">
		</td>
	</tr>
	</form>
	</table>
	</div>

<?php

}

// ***************************************************************************
// ***************************************************************************
// Removes HTML from Messages
function check_html ($str, $strip="") 
{
	/* The core of this code has been lifted from phpslash */
	/* which is licenced under the GPL. */
	if ($strip == "nohtml")
		$AllowableHTML=array('');
	$str = stripslashes($str);
	$str = eregi_replace("<[[:space:]]*([^>]*)[[:space:]]*>",'<\\1>', $str);
	   	    // Delete all spaces from html tags .
	$str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?[[:space:]]*([^\" >]*)[[:space:]]*\"?[^>]*>",'<a href="\\1">', $str);
	   	    // Delete all attribs from Anchor, except an href, double quoted.
	$str = eregi_replace("<[[:space:]]* img[[:space:]]*([^>]*)[[:space:]]*>", '', $str);
	    // Delete all img tags
	$str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?javascript[[:punct:]]*\"?[^>]*>", '', $str);
	    // Delete javascript code from a href tags -- Zhen-Xjell @ http://nukecops.com
	$tmp = "";
	while (ereg("<(/?[[:alpha:]]*)[[:space:]]*([^>]*)>",$str,$reg)) {
		$i = strpos($str,$reg[0]);
		$l = strlen($reg[0]);
		if ($reg[1][0] == "/") $tag = strtolower(substr($reg[1],1));
		else $tag = strtolower($reg[1]);
		if ($a = $AllowableHTML[$tag])
			if ($reg[1][0] == "/") $tag = "</$tag>";
			elseif (($a == 1) || ($reg[2] == "")) $tag = "<$tag>";
			else {
			  # Place here the double quote fix function.
			  $attrb_list=delQuotes($reg[2]);
			  // A VER
			  $attrb_list = ereg_replace("&","&amp;",$attrb_list);
			  $tag = "<$tag" . $attrb_list . ">";
			} # Attribs in tag allowed
		else $tag = "";
		$tmp .= substr($str,0,$i) . $tag;
		$str = substr($str,$i+$l);
	}
	$str = $tmp . $str;
	return $str;
	exit;
	/* Squash PHP tags unconditionally */
	$str = ereg_replace("<\?","",$str);
	return $str;
}


// ***************************************************************************
// ***************************************************************************
// Checks for the location of the torrents 
// If it does not exist, then it creates it.
function checkTorrentPath()
{
	global $cfg;
	// is there a stat and torrent dir?
	if (!is_dir($cfg["torrent_file_path"]))
	{
		//Then create it
		mkdir($cfg["torrent_file_path"], 0777);
	}
}

function checkMakeTorrentPath()
{
	global $cfg;
	// is there a stat and torrent dir?
	if (!is_dir($cfg["maketorrent_file_path"]))
	{
		//Then create it
		mkdir($cfg["maketorrent_file_path"], 0777);
	}
}

function checkLogPath()
{
	global $cfg;
	// is there a stat and torrent dir?
	if (!is_dir($cfg["log_path"]))
	{
		//Then create it
		mkdir($cfg["log_path"], 0777);
	}
}

// ***************************************************************************
// ***************************************************************************
// Returns the drive space used as a percentage i.e 85 or 95
function getDriveSpace($drive)
{
	$dt = disk_total_space($drive);
	$df = disk_free_space($drive);

	$percent = round((($dt - $df)/$dt) * 100);
	return $percent;
}

// ***************************************************************************
// ***************************************************************************
// Display the Drive Space Graphical Bar
function displayDriveSpaceBar($drivespace)
{
	global $cfg;
	$freeSpace = "";
	
	if ($drivespace > 20)
	{
		$freeSpace = " (".formatFreeSpace($cfg["free_space"])." Free)";
	}
?>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr nowrap>
		<td width="2%"><div class="tiny"><?php echo _STORAGE ?>:</div></td>
		<td width="80%">
			<table width="100%" border="0" cellpadding="0" cellspacing="0">
			<tr>
				<td background="themes/<?php echo $cfg["theme"] ?>/images/proglass.gif" width="<?php echo $drivespace ?>%"><div class="tinypercent" align="center"><?php echo $drivespace."%".$freeSpace ?></div></td>
				<td background="themes/<?php echo $cfg["theme"] ?>/images/noglass.gif" width="<?php echo (100 - $drivespace) ?>%"><img src="images/blank.gif" width="1" height="3" border="0"></td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
<?php
}

// ***************************************************************************
// ***************************************************************************
// Convert free space to GB or MB depending on size
function formatFreeSpace($freeSpace)
{
	$rtnValue = "";
	if ($freeSpace > 1024)
	{
		$rtnValue = number_format($freeSpace/1024, 2)." GB";
	}
	else
	{
		$rtnValue = number_format($freeSpace, 2)." MB";
	}
	
	return $rtnValue;
}

// ***************************************************************************
// ***************************************************************************
// Send Email Message
function sendEmail($subject, $message)
{
	global $cfg, $_SERVER;
	// Format and send an email
	$subject = $subject." ".$cfg["pagetitle"];
	$msg = "Message: ".$message."\n\n";
	$msg .= "Server Time: ".date("F j, Y, g:i a",time())."\n\n";
	$msg .= "______________________________________________________\n";
	$msg .= "User Name: ".$_SERVER['PHP_AUTH_USER']."\n";
	$msg .= "IP: ".getenv("REMOTE_ADDR")."\n";
	$msg .= getenv("HTTP_USER_AGENT")."\n";
	$msg .= "______________________________________________________\n\n";
	$to = $cfg["adminemail"];
	$mailheaders = "From: ".$_SERVER['PHP_AUTH_USER']." <".$cfg["adminemail"]."> \n";
	$mailheaders .= "Reply-To: ".$cfg["adminemail"]."\n";
	//$mailheaders .= "Bcc: qrome@yahoo.com\n";
	mail($to, $subject, $msg, $mailheaders);
}


//**************************************************************************
// getFileFilter()
// Returns a string used as a file filter.
// Takes in an array of file types.
function getFileFilter($inArray)
{
	$filter = "(\.".strtolower($inArray[0]).")|"; // used to hold the file type filter
	$filter .= "(\.".strtoupper($inArray[0]).")";
	// Build the file filter
	for($inx = 1; $inx < sizeof($inArray); $inx++)
	{
		$filter .= "|(\.".strtolower($inArray[$inx]).")";
		$filter .= "|(\.".strtoupper($inArray[$inx]).")";
	}
	$filter .= "$";
	return $filter;
}


//**************************************************************************
// getAliasName()
// Create Alias name for Text file and Screen Alias
function getAliasName($inName)
{
	$replaceItems = array(" ", ".", "-", "[", "]", "(", ")", "#", "&");
    $alias = str_replace($replaceItems, "_", $inName);
	$alias = strtolower($alias);
	$alias = str_replace("_torrent", "", $alias);

	return $alias;
}


//**************************************************************************
// cleanFileName()
// Remove bad characters that cause problems
function cleanFileName($inName)
{
	$replaceItems = array("'", ",", "#", "%", "!", "+", ":", "/", "\\", "@", "$", "&", "?");
    $cleanName = str_replace($replaceItems, "", $inName);

	return $cleanName;
}


//**************************************************************************
// usingTornado()
// returns true if client is tornado
function usingTornado()
{
	global $cfg;
	$rtnValue = false;
	if (preg_match("/btphptornado/i", $cfg["btphpbin"]))
	{
		$rtnValue = true;
	}

	return $rtnValue;
}

//**************************************************************************
// cleanURL()
// split on the "*" coming from Varchar URL
function cleanURL($url)
{
	$rtnValue = $url;
	$arURL = explode("*", $url);
	
	if (sizeof($arURL) > 1)
	{
		$rtnValue = $arURL[1];
	}
	
	return $rtnValue;
}

//**************************************************************************
// fetchURL()
// Downloads from a URL uses CURL if installed
function fetchURL($url)
{               
        global $cfg, $_SERVER, $db;
        $arhost = parse_url($url);
                
        $sql = "SELECT data FROM tf_cookies WHERE userid=".$db->qstr($cfg['user'])." AND host=".$db->qstr($arhost['host']);
        $cookie_data = $db->GetOne($sql);
        showError($db, $sql);
                
        $rtnValue = "";
         
        $url = cleanURL($url);
 
        if(strcmp(strtolower(substr($url, strlen($url)-8, 8)), ".torrent") == 0)
        {
                ini_set("allow_url_fopen", "1");
                ini_set("user_agent", $_SERVER["HTTP_USER_AGENT"]);
                $fp = @fopen($url, "r");
                if ($fp)
                {
                        while (!feof($fp))
                        {
                                $rtnValue .= fread($fp, 8192);
                        }
                        fclose($fp);
                }                    
        }
        else    
        {       
                $arhost = parse_url($url);
                $ch = curl_init();
                if($cookie_data != '')
                        curl_setopt($ch, CURLOPT_COOKIE, $cookie_data);
                if(!$arhost['port'] == '')
                        curl_setopt($ch, CURLOPT_PORT, $arhost['port']);
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_VERBOSE, FALSE);
                curl_setopt($ch, CURLOPT_HEADER, TRUE);
                curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER["HTTP_USER_AGENT"]);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                
                $response = curl_exec($ch);
                
                curl_close($ch);

                
                $trimmed = substr($response, 0, strpos($response, "d8:"));
                if (preg_match("/.torrent/i", $trimmed) && preg_match("/filename=/i", $trimmed))
                {       
                        // looks like there is a filename, lets grab it
                        $trimmed = substr($trimmed, strpos($trimmed, "filename=")+9);
                        $cfg["save_torrent_name"] = urldecode(substr($trimmed, 0, strpos(strtolower($trimmed), ".torrent")+8));
                }
                $rtnValue = substr($response, strpos($response, "d8:"));
                $rtnValue = rtrim($rtnValue, "\r\n");
        }
        
        // Make sure we have a torrent file
        if (strpos($rtnValue, "d8:") === false)
        {       
                // We don't have a Torrent File... it is something else
                AuditAction($cfg["constants"]["error"], "BAD TORRENT for: ".$url."\n".$rtnValue);
                $rtnValue = "";
        }
        return $rtnValue;
}

//**************************************************************************
// getDownloadSize()
// Grab the full size of the download from the torrent metafile
function getDownloadSize($torrent)
{
	$rtnValue = "";
	if (file_exists($torrent))
	{
		include_once("BDecode.php");
		$fd = fopen($torrent, "rd");
		$alltorrent = fread($fd, filesize($torrent));
		$array = BDecode($alltorrent);
		fclose($fd);
		$rtnValue = $array["info"]["piece length"] * (strlen($array["info"]["pieces"]) / 20);
	}
	return $rtnValue;
}

//**************************************************************************
// formatBytesToKBMGGB()
// Returns a string in format of GB, MB, or KB depending on the size for display
function formatBytesToKBMGGB($inBytes)
{
	$rsize = "";
	if ($inBytes > (1024 * 1024 * 1024))
	{
		$rsize = round($inBytes / (1024 * 1024 * 1024), 2) . " GB";
	}
	elseif ($inBytes < 1024 * 1024)
	{
		$rsize = round($inBytes / 1024, 1) . " KB";
	}
	else
	{
		$rsize = round($inBytes / (1024 * 1024), 1) . " MB";
	}
	return $rsize;
}

//**************************************************************************
// HealthData 
// Stores the image and title of for the health of a file.
class HealthData
{
	var $image = "";
	var $title = "";
}

//**************************************************************************
// getStatusImage() Takes in an AliasFile object
// Returns a string "file name" of the status image icon
function getStatusImage($af)
{
	$hd = new HealthData();
	$hd->image = "black.gif";
	$hd->title = "";

	if ($af->running == "1")
	{
		// torrent is running
		if ($af->seeds < 2)
		{
			$hd->image = "yellow.gif";
		}
		if ($af->seeds == 0)
		{
			$hd->image = "red.gif";
		}
		if ($af->seeds >= 2)
		{
			$hd->image = "green.gif";
		}
	}
	if ($af->percent_done >= 100)
	{
		if(trim($af->up_speed) != "" && $af->running == "1")
		{
			// is seeding
			$hd->image = "green.gif";
		} else {
			// the torrent is finished
			$hd->image = "black.gif";
		}
	}
	
	if ($hd->image != "black.gif")
	{
		$hd->title = "S:".$af->seeds." P:".$af->peers." ";
	}
	
	return $hd;
}

//**************************************************************************
// getDirList()
// This method Builds and displays the Torrent Section of the Index Page
function getDirList($dirName)
{
	global $cfg;
	include_once("AliasFile.php");
	$screenStatus = shell_exec("ps x -ww | grep python");
	$arList = array();
	$file_filter = getFileFilter($cfg["file_types_array"]);
	$handle = opendir($dirName);
	$lastUser = "";
	$arUserTorrent = array();
	$arListTorrent = array();

	while($entry = readdir($handle))
	{
		if ($entry != "." && $entry != "..")
		{
			if (is_dir($dirName."/".$entry))
			{
				// don''t do a thing
			}
			else
			{
				if (ereg($file_filter, $entry))
				{
					$key = filemtime($dirName."/".$entry).md5($entry);
					$arList[$key] = $entry;
				}
			}
		}
	}

	// sort the files by date
	krsort($arList);

	foreach($arList as $entry)
	{
		$output = "";
		$arStat = lstat($dirName.$entry);
		$timeStamp = $arStat[10];
		$fileSize = number_format(($arStat[7])/1024, 1);
		$displayname = $entry;
		$show_run = true;
		$file_stat = 0;
		$torrentowner = getOwner($entry);
		$owner = IsOwner($cfg["user"], $torrentowner);
		$kill_id = "";
		$estTime = "&nbsp;";
		$alias = getAliasName($entry).".stat";
		$af = new AliasFile($dirName.$alias, $torrentowner);
		if(!file_exists($dirName.$alias))
		{
			$af->running = "2"; // file is new
			$af->size = getDownloadSize($dirName.$entry);
			$af->WriteFile();
		}
		
	  if($cfg["hide_other_users_files"] && !IsAdmin() && !$owner) {
	   if(!$cfg["always_show_running_files"] || $af->running == "2") {
	     continue;
	    }
		}
		
		if(strlen($entry) >= 47) 
		{ 
			// needs to be trimmed
			$displayname = substr($entry, 0, 72);
			$displayname .= "...";
		}
		
		$hd = getStatusImage($af);
		
		$output .= "<tr><td class=\"tiny\"><img src=\"images/".$hd->image."\" width=16 height=16 title=\"".$hd->title.$entry."\" border=0 align=\"absmiddle\">".$displayname."</td>";
		$output .= "<td align=\"right\"><font class=\"tiny\">".formatBytesToKBMGGB($af->size)."</font></td>";
		$output .= "<td align=\"center\"><a href=\"message.php?to_user=".$torrentowner."\"><font class=\"tiny\">".$torrentowner."</font></a></td>";
		$output .= "<td valign=\"bottom\"><div align=\"center\">";
		
		$alias = getAliasName($entry).".stat";
		
		// find out if any screens are running and take their PID and make a KILL option
		$arScreen = array();
		$tok = strtok($screenStatus, "\n");
		while ($tok)
		{
			array_push($arScreen, $tok);
			$tok = strtok("\n");
		}

		for($i = 0; $i < sizeof($arScreen); $i++)
		{
			if(strpos($arScreen[$i], getAliasName($entry)) !== false)
			{
				$kill_temp = preg_replace("/^( )*/", "", $arScreen[$i]);
				$arTemp = explode(" ", $kill_temp);
				if ($kill_id == "")
				{
					$kill_id = $arTemp[0];
				}
				else
				{
					// there is more than one PID for this torrent
					// Add it so it can be killed as well.
					$kill_id .= "|".$arTemp[0];
				}
			}
		}
		
			
		if ($af->running != "2")
		{
			if ($af->time_left != "" && $af->time_left != "0")
			{
				$estTime = $af->time_left;
			}
			
			// Check to see if the torrent was stoped outside of TF
			if(($af->percent_done < 100) && ($af->percent_done >= 0) && ($kill_id == ""))
			{
				// The file is not running and the percent done needs to be changed
				$af->percent_done = ($af->percent_done+100)*-1;
				$af->running = "0";
				$af->time_left = "Torrent Died";
				$af->up_speed = "";
				$af->down_speed = "";
				// write over the status file so that we can display a new status
				$af->WriteFile();
			}
			
			$lastUser = $torrentowner;
			$sharing = $af->sharing."%";
			$graph_width = 1;
			$progress_color = "#00ff00";
			$background = "#000000";
			$bar_width = "4";
			$popup_msg = _ESTIMATEDTIME.": ".$af->time_left;
			$popup_msg .= "<br>"._DOWNLOADSPEED.": ".$af->down_speed;
			$popup_msg .= "<br>"._UPLOADSPEED.": ".$af->up_speed;
			$popup_msg .= "<br>"._SHARING.": ".$sharing;
			$popup_msg .= "<br>Seeds: ".$af->seeds;
			$popup_msg .= "<br>Peers: ".$af->peers;
			$popup_msg .= "<br>"._USER.": ".$torrentowner;
			
			// incriment the totals
			$cfg["total_upload"] = $cfg["total_upload"] + GetSpeedValue($af->up_speed);
			$cfg["total_download"] = $cfg["total_download"] + GetSpeedValue($af->down_speed);
			
			if($af->percent_done >= 100)
			{
			if(trim($af->up_speed) != "" && $af->running == "1") 
				{
					if ($af->seedlimit > 0 && GetSpeedInBytes($af->up_speed) > 0)
						$timeleft = "<br>" . SecondsToDate(((($af->seedlimit)/100 * $af->size) - $af->uptotal)/GetSpeedInBytes($af->up_speed)) . " left";
					else
						$timeleft = "";
					$return = "seeding (".$af->up_speed.") ".$sharing . "$timeleft";
					$output .= "<a href=\"JavaScript:ShowDetails('downloaddetails.php?alias=".$alias."&torrent=".urlencode($entry)."')\" style=\"font-size:7pt;\" onmouseover=\"return overlib('".$popup_msg."<br>', CSSCLASS);\" onmouseout=\"return nd();\">$return</a>";
				}
				else 
				{
					$output .= "<a href=\"JavaScript:ShowDetails('downloaddetails.php?alias=".$alias."&torrent=".urlencode($entry)."')\" onmouseover=\"return overlib('".$popup_msg."<br>', CSSCLASS);\" onmouseout=\"return nd();\"><i><font color=red>"._DONE."</font></i></a>";
				}
				$file_stat = 100;
				$show_run = false;
			}
			else if ($af->percent_done < 0)
			{
				$output .= "<a href=\"JavaScript:ShowDetails('downloaddetails.php?alias=".$alias."&torrent=".urlencode($entry)."')\" onmouseover=\"return overlib('".$popup_msg."<br>', CSSCLASS);\" onmouseout=\"return nd();\"><i><font color=\"#989898\">"._INCOMPLETE."</font></i></a>";
				$show_run = true;
			}
			else
			{
				if($af->percent_done > 1)
				{
					$graph_width = $af->percent_done;
				}
				if($graph_width == 100)
				{
					$background = $progress_color;
				}
				$output .= "<a href=\"JavaScript:ShowDetails('downloaddetails.php?alias=".$alias."&torrent=".urlencode($entry)."')\" onmouseover=\"return overlib('".$popup_msg."<br>', CSSCLASS);\" onmouseout=\"return nd();\">";
				$output .= "<font class=\"tiny\"><strong>".$af->percent_done."%</strong> @ ".$af->down_speed."</font></a><br>";
				$output .= "<table width=\"100\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
				$output .= "<tr><td background=\"themes/".$cfg["theme"]."/images/progressbar.gif\" bgcolor=\"".$progress_color."\"><img src=\"images/blank.gif\" width=\"".$graph_width."\" height=\"".$bar_width."\" border=\"0\"></td>";
				$output .= "<td bgcolor=\"".$background."\"><img src=\"images/blank.gif\" width=\"".(100 - $graph_width)."\" height=\"".$bar_width."\" border=\"0\"></td>";
				$output .= "</tr></table>";
			}
			
		}
		else
		{
			$output .= "<i><font color=\"#32cd32\">"._NEW."</font></i>";
		}
		$output .= "</div></td>";
		$output .= "<td><div class=\"tiny\" align=\"center\">".$estTime."</div></td>";
		$output .= "<td><div align=center>";

		$torrentDetails = _TORRENTDETAILS;
		if ($lastUser != "")
		{
			$torrentDetails .= "\n"._USER.": ".$lastUser;
		}

		$output .= "<a href=\"details.php?torrent=".urlencode($entry)."\"><img src=\"images/properties.png\" width=18 height=13 title=\"".$torrentDetails."\" border=0></a>";

		if ($owner || IsAdmin($cfg["user"]))
		{
			if($kill_id != "" && $af->percent_done >= 0 && $af->running == 1)
			{
				
				$output .= "<a href=\"index.php?alias_file=".$alias."&kill=".$kill_id."&kill_torrent=".urlencode($entry)."\"><img src=\"images/kill.gif\" width=16 height=16 title=\""._STOPDOWNLOAD."\n"._USER.": ".$lastUser."\" border=0></a>";
				$output .= "<img src=\"images/delete_off.gif\" width=16 height=16 border=0>";
				$output .= "<input type=\"checkbox\" disabled=\"disabled\">";

			}
			else
			{
				if($torrentowner == "n/a")
				{
					$output .= "<img src=\"images/run_off.gif\" width=16 height=16 border=0 title=\""._NOTOWNER."\">";
				}
				else
				{
					// Allow Avanced start popup?
					if ($cfg["advanced_start"]) 
					{
						if($show_run)
						{
							$output .= "<a href=\"#\" onclick=\"StartTorrent('startpop.php?torrent=".urlencode($entry)."')\"><img src=\"images/run_on.gif\" width=16 height=16 title=\""._RUNTORRENT."\" border=0></a>";
						}
						else
						{
							$output .= "<a href=\"#\" onclick=\"StartTorrent('startpop.php?torrent=".urlencode($entry)."')\"><img src=\"images/seed_on.gif\" width=16 height=16 title=\""._SEEDTORRENT."\" border=0></a>";
						}
					}
					else
					{
						// Quick Start
						if($show_run)
						{
							$output .= "<a href=\"".$_SERVER['PHP_SELF']."?torrent=".urlencode($entry)."\"><img src=\"images/run_on.gif\" width=16 height=16 title=\""._RUNTORRENT."\" border=0></a>";
						}
						else
						{
							$output .= "<a href=\"".$_SERVER['PHP_SELF']."?torrent=".urlencode($entry)."\"><img src=\"images/seed_on.gif\" width=16 height=16 title=\""._SEEDTORRENT."\" border=0></a>";
						}
					}
				}
	
				$deletelink = $_SERVER['PHP_SELF']."?alias_file=".$alias."&delfile=".urlencode($entry);
				$output .= "<a href=\"".$deletelink."\" onclick=\"return ConfirmDelete('".$entry."')\"><img src=\"images/delete_on.gif\" width=16 height=16 title=\""._DELETE."\" border=0></a>";
				$output .= "<input type=\"checkbox\" name=\"torrent[]\" value=\"".urlencode($entry)."\">";
			}
		}
		else
		{
			$output .= "<img src=\"images/locked.gif\" width=16 height=16 border=0 title=\""._NOTOWNER."\">";
			$output .= "<img src=\"images/locked.gif\" width=16 height=16 border=0 title=\""._NOTOWNER."\">";
			$output .= "<input type=\"checkbox\" disabled=\"disabled\">";
		}
		$output .= "</div>";

		$output .= "</td>";
		$output .= "</tr>\n";
		
		// Is this torrent for the user list or the general list?
		if ($cfg["user"] == getOwner($entry))
		{
			array_push($arUserTorrent, $output);
		}
		else
		{
			array_push($arListTorrent, $output);
		}
	}
	closedir($handle);
	
	// Now spit out the junk
	echo "<table bgcolor=\"".$cfg["table_data_bg"]."\" width=\"100%\" bordercolor=\"".$cfg["table_border_dk"]."\" border=1 cellpadding=3 cellspacing=0>";
	
	if (sizeof($arUserTorrent) > 0)
	{
		echo "<tr><td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"37%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">".$cfg["user"].": "._TORRENTFILE."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"8%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._SIZE."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"10%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._USER."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"19%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._STATUS."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"18%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._ESTIMATEDTIME."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"8%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._ADMIN."</div></td>";
		echo "</tr>\n";
		foreach($arUserTorrent as $torrentrow)
		{
			echo $torrentrow;
		}
	}
	
	if (sizeof($arListTorrent) > 0)
	{
		echo "<tr><td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"40%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._TORRENTFILE."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"10%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._FILESIZE."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"10%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._USER."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"10%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._STATUS."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"20%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._ESTIMATEDTIME."</div></td>";
		echo "<td background=\"themes/".$cfg["theme"]."/images/bar.gif\" width=\"10%\" bgcolor=\"".$cfg["table_header_bg"]."\"><div align=center class=\"title\">"._ADMIN."</div></td>";
		echo "</tr>\n";
		foreach($arListTorrent as $torrentrow)
		{
			echo $torrentrow;
		}
	}
}
?>
